
<template>
  <div class='m-container'>
    <h2>
      <div class="squrt"></div>商品分类管理
    </h2>
    <div class="m-core">
      <div class='newBand'
           v-permission="'category/upset'"
           @click="openTypes('create')">添加</div>
      <!-- 列表 -->
      <div class="tableWrap">
        <el-table :data='tableList'
                  :header-cell-style="{background:'#EDEEF0',color:'#444'}">
          <el-table-column align='center'
                           prop="name"
                           label="分类名称">
          </el-table-column>
          <el-table-column align='center'
                           label="声部属性">
            <template slot-scope="scope">
              <overflow-text width="100%" :text="scope.row.subjectName | joinArray(',')"></overflow-text>
            </template>
          </el-table-column>
          <el-table-column align='center'
                           label="操作">
            <template slot-scope="scope">
              <el-button @click="openTypes('update', scope.row)"
                         v-permission="'category/upset'"
                         type="text">修改</el-button>
              <el-button @click="onTypesDelOpeation(scope.row)"
                         v-permission="'category/del'"
                         type="text">删除</el-button>
            </template>
          </el-table-column>
        </el-table>
        <pagination :total="pageInfo.total"
                    :page.sync="pageInfo.page"
                    :limit.sync="pageInfo.limit"
                    :page-sizes="pageInfo.page_size"
                    @pagination="getList" />
      </div>
    </div>
    <el-dialog :title="formTitle[formActionTitle]"
               :visible.sync="typeStatus"
               @close="onFormClose('ruleForm')"
               width="500px">
      <el-form :model="form"
               :rules="rules"
               ref="ruleForm">
        <el-form-item label="商品分类名称"
                      prop="name"
                      :label-width="formLabelWidth">
          <el-input v-model.trim="form.name"
                    autocomplete="off"></el-input>
        </el-form-item>
        <el-form-item label="声部属性"
                      v-if="form.classGroupType != 'MIX'"
                      prop="subjectIds"
                      :label-width="formLabelWidth">
          <el-select v-model.trim="form.subjectIds"
                     clearable
                     filterable
                     multiple>
            <el-option-group v-for="group in subjectList"
                             :key="group.label"
                             :label="group.label">
              <el-option v-for="item in group.options"
                         :key="item.value"
                         :label="item.label"
                         :value="item.value">
              </el-option>
            </el-option-group>
          </el-select>
        </el-form-item>
      </el-form>
      <span slot="footer"
            class="dialog-footer">
        <el-button @click="typeStatus = false">取 消</el-button>
        <el-button type="primary"
                   @click="onTypesSubmit('ruleForm')">确 定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import pagination from '@/components/Pagination/index'
import store from '@/store'
import { subjectListTree } from '@/api/specialSetting'
import { categoryListTree, categoryUpSet, categoryUpSetDel } from '@/api/businessManager'
export default {
  components: { pagination },
  name: 'shopCategory',
  data () {
    return {
      tableList: [],
      subjectList: [], // 声部列表
      formActionTitle: 'create',
      formTitle: {
        create: '添加商品分类',
        update: '修改商品分类'
      },
      typeStatus: false, // 添加教学点
      formLabelWidth: '120px',
      form: {
        name: null, // 作业模块名称
        subjectIds: []
      },
      rules: {
        name: [{ required: true, message: '请输入类型名称', trigger: 'blur' }],
        subjectIds: [{ required: true, message: '请选择声部组合', trigger: 'change' }]
      },
      pageInfo: {
        // 分页规则
        limit: 10, // 限制显示条数
        page: 1, // 当前页
        total: 0, // 总条数
        page_size: [10, 20, 40, 50] // 选择限制显示条数
      }
    }
  },
  mounted () {
    this.getList()
    this.getSubjectTree()
  },
  methods: {
    onTypesDelOpeation (row) {

      this.$confirm("您确定删除该分类?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        categoryUpSetDel({ id: row.id }).then(res => {
          this.messageTips('删除', res)
        })
      });

    },
    onTypesSubmit (formName) { // 添加数据
      this.$refs[formName].validate((valid) => {
        if (valid) {
          if (this.formActionTitle == 'create') {
            if (this.form.id) { // 判断有没有Id，如果有则删除
              delete this.form.id
            }
            categoryUpSet(this.form).then(res => {
              this.messageTips('添加', res)
            })
          } else if (this.formActionTitle == 'update') {
            categoryUpSet(this.form).then(res => {
              this.messageTips('修改', res)
            })
          }
        } else {
          return false;
        }
      })
    },

    messageTips (title, res) {
      if (res.code == 200) {
        this.$message.success(title + '成功')
        this.typeStatus = false
        this.getList()
      } else {
        this.$message.error(res.msg)
      }
    },
    getList () {
      categoryListTree({
        delFlag: 0,
        rows: this.pageInfo.limit,
        page: this.pageInfo.page
      }).then(res => {
        let result = res.data
        if (res.code == 200) {
          result.rows.forEach(row => {
            let subjectname = [],
              subjectIds = []
            row.subjects.forEach(item => {
              subjectname.push(item.name)
              subjectIds.push(item.id)
            })
            row.subjectName = subjectname
            row.subjectIds = subjectIds
          })
          this.tableList = result.rows
          this.pageInfo.total = result.total
        }
      })
    },
    openTypes (type, row) {
      this.typeStatus = true
      this.formActionTitle = type
      // 修改的时候赋值
      if (type == 'update') {
        this.form = {
          id: row.id,
          name: row.name,
          subjectIds: row.subjectIds
        }
      }
    },
    onFormClose (formName) { // 关闭弹窗重置验证
      this.form = {
        name: null, // 作业模块名称
        subjectIds: []
      }
      this.$refs[formName].resetFields()
    },
    getSubjectTree () { // 获取声部列表
      subjectListTree({
        delFlag: 0,
        rows: 9999
      }).then(res => {
        let result = res.data
        if (res.code == 200) {
          let tempArray = []
          result.rows.forEach((item, index) => {
            let subject = []
            item.subjects.forEach(s => {
              subject.push({
                value: s.id,
                label: s.name
              })
            })

            tempArray[index] = {
              label: item.name,
              options: subject
            }
          })
          this.subjectList = tempArray
        }
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.el-button--primary {
  background: #14928a;
  border-color: #14928a;
  color: #fff;
  &:hover,
  &:active,
  &:focus {
    background: #14928a;
    border-color: #14928a;
    color: #fff;
  }
}
/deep/.el-date-editor.el-input {
  width: 100% !important;
}
/deep/.el-select {
  width: 100% !important;
}
</style>
